<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCommentHistoricalResult_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfCommentHistoricalResult_V3 extends AbstractStructArrayBase
{
    /**
     * The CommentHistoricalResult_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CommentHistoricalResult_V3[]
     */
    public $CommentHistoricalResult_V3;
    /**
     * Constructor method for ArrayOfCommentHistoricalResult_V3
     * @uses ArrayOfCommentHistoricalResult_V3::setCommentHistoricalResult_V3()
     * @param \StructType\CommentHistoricalResult_V3[] $commentHistoricalResult_V3
     */
    public function __construct(array $commentHistoricalResult_V3 = array())
    {
        $this
            ->setCommentHistoricalResult_V3($commentHistoricalResult_V3);
    }
    /**
     * Get CommentHistoricalResult_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CommentHistoricalResult_V3[]|null
     */
    public function getCommentHistoricalResult_V3()
    {
        return isset($this->CommentHistoricalResult_V3) ? $this->CommentHistoricalResult_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCommentHistoricalResult_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCommentHistoricalResult_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCommentHistoricalResult_V3ForArrayConstraintsFromSetCommentHistoricalResult_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCommentHistoricalResult_V3CommentHistoricalResult_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfCommentHistoricalResult_V3CommentHistoricalResult_V3Item instanceof \StructType\CommentHistoricalResult_V3) {
                $invalidValues[] = is_object($arrayOfCommentHistoricalResult_V3CommentHistoricalResult_V3Item) ? get_class($arrayOfCommentHistoricalResult_V3CommentHistoricalResult_V3Item) : sprintf('%s(%s)', gettype($arrayOfCommentHistoricalResult_V3CommentHistoricalResult_V3Item), var_export($arrayOfCommentHistoricalResult_V3CommentHistoricalResult_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CommentHistoricalResult_V3 property can only contain items of type \StructType\CommentHistoricalResult_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CommentHistoricalResult_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CommentHistoricalResult_V3[] $commentHistoricalResult_V3
     * @return \ArrayType\ArrayOfCommentHistoricalResult_V3
     */
    public function setCommentHistoricalResult_V3(array $commentHistoricalResult_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($commentHistoricalResult_V3ArrayErrorMessage = self::validateCommentHistoricalResult_V3ForArrayConstraintsFromSetCommentHistoricalResult_V3($commentHistoricalResult_V3))) {
            throw new \InvalidArgumentException($commentHistoricalResult_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($commentHistoricalResult_V3) || (is_array($commentHistoricalResult_V3) && empty($commentHistoricalResult_V3))) {
            unset($this->CommentHistoricalResult_V3);
        } else {
            $this->CommentHistoricalResult_V3 = $commentHistoricalResult_V3;
        }
        return $this;
    }
    /**
     * Add item to CommentHistoricalResult_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\CommentHistoricalResult_V3 $item
     * @return \ArrayType\ArrayOfCommentHistoricalResult_V3
     */
    public function addToCommentHistoricalResult_V3(\StructType\CommentHistoricalResult_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CommentHistoricalResult_V3) {
            throw new \InvalidArgumentException(sprintf('The CommentHistoricalResult_V3 property can only contain items of type \StructType\CommentHistoricalResult_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CommentHistoricalResult_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CommentHistoricalResult_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CommentHistoricalResult_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CommentHistoricalResult_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CommentHistoricalResult_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CommentHistoricalResult_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CommentHistoricalResult_V3
     */
    public function getAttributeName()
    {
        return 'CommentHistoricalResult_V3';
    }
}
